* RoClSend V0.9 QRT 171197 
*
* qrt@qland.de

* 8051 Assembler bit-assignments
* PSW
CY      BIT     $D7
AC      BIT     $D6
F0      BIT     $D5
RS1     BIT     $D4
RS0     BIT     $D3
OV      BIT     $D2
P       BIT     $D0
* TCON
TF1     BIT     $8F
TR1     BIT     $8E
TF0     BIT     $8D
TR0     BIT     $8C
IE1     BIT     $8B
IT1     BIT     $8A
IE0     BIT     $89
IT0     BIT     $88
* T2CON
TR2     BIT     $CA
TF2     BIT     $CF
* IE
EA      BIT     $AF
ES      BIT     $AC
ET1     BIT     $AB
EX1     BIT     $AA
ET0     BIT     $A9
EX0     BIT     $A8
ET2     BIT     $AD
* IP
PS      BIT     $BC
PT1     BIT     $BB
PX1     BIT     $BA
PT0     BIT     $B9
PX0     BIT     $B8
PT2     BIT     $BD
* P3
RD      BIT     $B7
WR      BIT     $B6
T1      BIT     $B5
T0      BIT     $B4
INT1    BIT     $B3
INT0    BIT     $B2
TXD     BIT     $B1
RXD     BIT     $B0
* SCON
SM0     BIT     $9F
SM1     BIT     $9E
SM2     BIT     $9D
REN     BIT     $9C
TB8     BIT     $9B
RB8     BIT     $9A
TI      BIT     $99
RI      BIT     $98

        ORG     $0000           ROM Starts here
        LJMP    main
        ORG     $0003
        LJMP    Ext0Int
        ORG     $000b
        LJMP    Timer0Int
        ORG     $0013
        LJMP    Ext1Int
*        ORG     $001b
*        LJMP    Timer1Int
*        ORG     $0023
*        LJMP    SerInt
*        ORG     $002b
*        LJMP    Timer2Int

?R0     EQU     0
?R1     EQU     ?R0+1
?R2     EQU     ?R0+2
?R3     EQU     ?R0+3
?R4     EQU     ?R0+4
?R5     EQU     ?R0+5
?R6     EQU     ?R0+6
?R7     EQU     ?R0+7


* DCFdira.h IR-gesteuerter DCF-Empfang, version for assembler QRT121097
*
*
*   _INT1       _DCF Signal
*   Timer0      Sekundentakt
*
*   T0ovc = Timer0 Overflow Counter, wird alle 2^16 Zyklen inkrementiert
*           insgesamt 14 mal dann wird Timer0 mit einem Restwert geladen
*           der 15. OV bedeutet die neue Sekunde
*
*   bei f=11,05920 MHz -> Z=1,08506944 us (Zyklenzeit)
*   1 s = 1/Z = 921600 Z/s
*   1+2+2+14 + 1+2+2+20 = 44 Befehlszyklen pro s zur Timersteuerung:
*   Reaktion + jmp zu IR-Ad + jmp zu IR-Routine + Code fr laden beim vorletzten Timerlauf +
*   Reaktion + jmp zu IR-Ad + jmp zu IR-Routine + Code fr laden beim letzten Timerlauf
*   Restwert = 921600 - ( 14 * 2^16 + 44 ) = 4052 (theoretischer Wert)
*   Praxiswert mit Quarz dieses Systems 3841 = 0,23 %o Abweichung
*
*   bei f=15 MHz -> Z=0,8 us
*   1 s = 1/Z = 1,25 * 10^6 Z/s
*   Restwert = 1,25 * 10^6 -( 19 * 2^16 + 44 ) = 4772 (theoretisch)
*   Praxiswert 4995 (+ langsamer, - schneller) neuer Wert 5035
*
*                               1 1 1 1 1 1
*   T0ovc     0 1 2 3 4 5 6 7 9 0 1 2 3 4 5
*
*    _DCF  '''|__|''''''''''''''''''''''|_      100 ms = 0
*
*    _DCF  '''|____|''''''''''''''''''''|_      200 ms = 1
*
*    _DCF  '''''''''''''''''''''''''''''|_      sec 59 (Impuls fehlt)
*
*   Pegel von _DCF zum Zeitpunkt T0ovc=1 in dcfst bit 2 (ov1)
*                                T0ovc=2 in dcfst bit 3 (ov2)
*
*
*   dcfst       bit 7 6 5 4 3 2 1 0
*                   s t     o o d s
*                   y s     v v a e
*                   n y     2 1 t c
*                   c n         a s
*                     c         s y
*                               y n
*                               n c
*                               c
*
*   sync        = Hauptschalter fr sync, verzweigt in sync-Routine
*   tsync       = Flag ob auf DCF-Sekunden-Impuls syncronisiert wurde
*   secsync     = Flag ob auf Sekunde (59) syncronisiert wurde
*   datasync    = Flag ob DCF-Daten gltig sind, wird gleich nach Datenbernahme gelscht
*   ov1, ov2    = Mebits zur Bestimmung ob im DCF-Signal log 0/1 oder sec 59 bertragen wurde
*
*   dcfst mu im DATA RAM liegen
*   dcfst = $cd -> Uhrzeit und Datum gestellt und gltig
*
*
*       | nti + 5                 | nti + 4                 | nti + 3
*       |                         |                         |
*   bit |  7  6  5  4  3  2  1  0 |  7  6  5  4  3  2  1  0 |  7  6  5  4  3  2  1  0
*   sec | 58 57 56 55 54 53 52 51 | 50 49 48 47 46 45 44 43 | 42 41 40 39 38 37 36 35
*   inf | P3 y7 y6 y5 y4 y3 y2 y1 | y0 m4 m3 m2 m1 m0 w2 w1 | w0 d5 d4 d3 d2 d1 d0 P2
*
*       | nti + 2                 | nti + 1                 | nti + 0
*       |                         |                         |
*   bit |  7  6  5  4  3  2  1  0 |  7  6  5  4  3  2  1  0 |  7  6  5  4  3  2  1  0
*   sec | 34 33 32 31 30 29 28 27 | 26 25 24 23 22 21 20 19 | 18 17 16 15 14 13 12 11
*   inf | h5 h4 h3 h2 h1 h0 P1 m6 | m5 m4 m3 m2 m1 m0 S     |    SZ A  R
*
*   R = Antennenbit (=Reserveantenne)
*   A = (1=1h vor Sommer-Winterzeitwechsel)
*   SZ= Sommer/Winterzeit
*   S = Startbit der Zeitinformation
*   Px= Prfbits (Bitanzahl bis Px wird auf gerade Zahl ergnzt)
*
*   (lt. Elektor Oktober 1980 S. 44f)
*
*
*   known bugs, some hints
*
*   - manchmal gelingt die Syncronisation der Uhr nicht gleich nach dem Start des Programms,
*     Grund unbekannt (Empfangsstrungen?), Uhr stellt sich jedoch nach ein paar Minuten ein
*
*   - sollte der Empfang um Mitternacht nicht mglich sein, werden die Datumsinformationen
*     erst beim nchst mglichen Empfang aktualisiert, die Zeit luft whrenddessen korrekt weiter
*
*   - secbit 0 wird auch als M=Minutenmarke bezeichnet, ob M mit zur Paritt von P1 beitrgt
*     oder erst secbit 1 ist unbekannt, im Programm wird M nicht mit gewertet
*
*   - sec-bits 1-14 werden nicht aufgehoben (2 Byte sparen) da bis heute darin nur
*     Nullen bertragen werden
*
*   - nti+0 bits 0-3 enthlt die Paritt der secbits 1-14 um P1 korrekt auswerten
*     zu knnen (falls in Zukunft hier Informationen bertragen werden)
*
*   - in nti+0 stehen die bits SZ, A, R zur Verfgung
*
*   - die DCF-Information lt sich jederzeit aktualisieren, einfach dcfst auf Null setzen,
*     jede volle Stunde (zur 58. Minute) startet das Programm automatisch seine Syncronisation
*
*   - _INT1-IR und Timer0-IR laufen beide mit Prioritt 1, da Timer0-IR in meiner Anwendung
*     mit Prioritt 0 eine LED-Anzeige aktualisiert, wrde Timer0-IR mit Prioritt 0 laufen
*     wre die Gangreserve der Uhr uerst ungenau
*
*   - die Variable day hlt in bits 0-4 den Tag und in bits 5-7 den Wochentag


sec     EQU $09
min     EQU $0a
hou     EQU $0b
day     EQU $0c
month   EQU $0d
year    EQU $0e
omonth  EQU $0f
oyear   EQU $10
T0ovc   EQU $11
hsec    EQU $12
nti     EQU $13     ... $18

dcfst   EQU $20     BIT RAM

rval    EQU     -3841           Restwert auf 1 s fr Timer0
ovs     EQU     14              19 15 MHz, 14 bei 11 MHz, Overflows fr 1 s
mes1    EQU     1               Messzyklus fr 100 ms
mes2    EQU     2               Messzyklus fr 200 ms, 2 bei 11 MHz, 3 bei 15 MHz

InitDCF
        anl     TMOD,#$f0       T0 vorbereiten ohne T1 zu verndern
        orl     TMOD,#$01       Gate0=0, c/t0=0, Mode1=01 16-bit
        setb    PT0             Timer0 Prioritt

        setb    IT1             Flanken-Triggerung ExtIR1 vorbereiten
        setb    PX1             Prioritt ExtIR1
        clr     EX1             Ext1IR disable (enable erst vor Tsync)

        mov     sec,#0          Zeitinfos auf Null setzen
        mov     min,#0
        mov     hou,#0
        mov     day,#0
        mov     month,#0
        mov     year,#0
        mov     dcfst,#0        Syncronisation freigeben
        acall   ResetT0

        setb    ET0             T0-IR enable
        setb    EA              alle IR's enable
        ret

Ext1Int
        push    PSW
        push    A

        mov     A,T0ovc         T0ovc merken
        acall   ResetT0         T0 so schnell wie mglich Reset
        clr     TF0             falls T0 bis hierher berlauf hatte

        cjne    A,#ovs-2,*+3
        jc      e1i1            EX1-IR kurz vor T0-IR? (T0ovc>=ovs-2?)
        acall   IncTime         ja, IncTime sonst fehlt 1 sec

e1i1
*                               nein, kein IncTime
        clr     EX1             ExtIR1 disable, nur ein mal Tsync
        setb    dcfst.6         Tsync ausgefhrt

        pop     A
        pop     PSW
        reti

Timer0Int
        push    PSW
        push    A

        inc     T0ovc
        mov     A,T0ovc
        cjne    A,#ovs,t0i1     T0ovc=ovs?
        clr     TR0             ja, Timer0 stop
        mov     TL0,#rval       Timer0 mit Rest auf 1 s laden, Lowbyte
        mov     TH0,#=rval      Highbyte rval
        setb    TR0             Timer0 starten
        ajmp    t0i9            exit

t0i1    cjne    A,#ovs+1,t0i2   nein, T0ovc=ovs+1?
        acall   ResetT0         ja, Timer0 Reset
        acall   IncTime         Zeitzhler erhhen
        ajmp    t0i9            exit

t0i2    jb      dcfst.7,t0i9    schon Sync?
        acall   SyncClock       nein, ausfhren

t0i9    pop     A
        pop     PSW
        reti

IncTime
        inc     sec
        mov     A,sec
        cjne    A,#60,?it1

        mov     sec,#0          zur neuen Minute
        jnb     dcfst.1,it2     Datasync gltig?
        ajmp    DataSet         ja, Daten bernehmen

it2     inc     min             nein, Minute normal erhhen
        mov     A,min

        cjne    A,#58,it3       alle Stunde Uhr stellen
        mov     dcfst,#0

it3     cjne    A,#60,?it1

        mov     min,#0
        inc     hou
        mov     A,hou
        cjne    A,#24,?it1

        mov     hou,#0

?it1    ret

DataSet
        setb    dcfst.7         Sync ausgefhrt, vorab wegen Sicherheitsprfung
        clr     dcfst.1         Datasync entwerten, nur ein mal gltig

        mov     A,nti+4         year, zuerst um Fehler zu vermeiden
        mov     C,A.7
        mov     A,nti+5
        rlc     A
        acall   DecBin
        acall   Tyear           Prfung
        jc      da1             wenn Fehler, oder 1. Empfang
        mov     year,A

da1     mov     A,nti+4         month
        rr      A
        rr      A
        anl     A,#%00011111
        acall   DecBin
        acall   Tmonth          Prfung
        jc      dse             wenn Fehler, oder 1. Empfang
        mov     month,A

        mov     A,nti+2         min bit 6 in nti+2 bit 0
        mov     C,A.0           in CY kopieren
        mov     A,nti+1         min bit 5-0 in nti+1 bit 7-2
        rrc     A               min komplettieren C->7->6..
        clr     C               min bit 7=0 sicherstellen
        rrc     A               stellenrichtig dec-Z in HByte dec-E in LByte
        acall   DecBin          in Binrzahl umrechnen
        mov     min,A           speichern

        mov     A,nti+2         h bit 5-0  in nti+1 bit 7-2
        rr      A               stellenrichtig
        rr      A
        anl     A,#$3f          bit 7+6 ausblenden
        acall   DecBin
        mov     hou,A

        mov     A,nti+3         day
        rr      A
        anl     A,#%00111111
        acall   DecBin
        mov     day,A

        mov     A,nti+3         weekday
        mov     C,A.7
        mov     A,nti+4
        rlc     A
        anl     A,#%00000111
        acall   DecBin
        rl      A
        rl      A
        rl      A
        rl      A
        rl      A
        orl     day,A           bits 7-5 weekday und bits 4-0 day
dse     ret

Tyear   cjne    A,oyear,ty1     neues = altes year?
        clr     C               ja, alles ok
        ret                     zurck

ty1     xch     A,oyear         nein
        inc     A               oyear+1
        cjne    A,#100,ty2      wenn=100
        mov     A,#0            dann 0
ty2     xch     A,oyear
        cjne    A,oyear,ty3     neues = altes year + 1?
        clr     C               ja, alles ok
        ret                     zurck

ty3     mov     oyear,A         nein, neu in alt
        mov     dcfst,#0        Sync noch mal von vorn
        setb    C               mit Fehler zurckkehren
        ret

Tmonth  cjne    A,omonth,tm1    neuer = alter month?
        clr     C               ja, alles ok
        ret                     zurck

tm1     xch     A,omonth        nein
        inc     A               omonth+1
        cjne    A,#13,tm2       wenn=13
        mov     A,#1            dann 1
tm2     xch     A,omonth
        cjne    A,omonth,tm3    neuer = alter month + 1?
        clr     C               ja, alles ok
        ret                     zurck

tm3     mov     omonth,A        nein, neu in alt
        mov     dcfst,#0        Sync noch mal von vorn
        setb    C               mit Fehler zurckkehren
        ret

DecBin
        push    B

        push    A
        swap    A               HByte A * 10 + LByte A
        anl     A,#$0f
        mov     B,#10
        mul     AB
        mov     B,A
        pop     A
        anl     A,#$0f
        add     A,B

        pop     B
        ret

SyncClock
        cjne    A,#mes1,sc1     nein, mes1. Timer0 OV?
        clr     dcfst.2         ja, bit 2 lschen
        jnb     INT1,sc9        INT1=1? nein, exit
        setb    dcfst.2         ja, bit 2 setzen
sc9     ret

sc1     cjne    A,#mes2,sc9     nein, mes2. Timer0 OV? nein, exit
        clr     dcfst.3         ja, bit 3 lschen
        jnb     INT1,sc3        INT1=1?
        setb    dcfst.3         ja, bit 3 setzen

sc3     jb      dcfst.6,sc4     nein, schon Tsync?
        clr     IE1             nein, ev. INT1-IR lschen
        setb    EX1             nchster INT1-IR tut es
        mov     hsec,#0         ab hier max. 60 s Zeit fr Secsync
        ret                     einstweilen exit

sc4     jb      dcfst.0,sc2     ja, schon Secsync?
        ajmp    Secsync         nein, ausfhren und exit

sc2     jb      dcfst.1,sc9     ja, schon Datasync? ja, exit

Datasync
*                               59: Secsync, 00-58: Datasync
*                               6 x 8 = 48 bit aufheben
*                               nti+0 bit 0 = dcfbit 11
*                               nti+5 bit 7 = dcfbit 58

        mov     C,dcfst.3       bit 3 ins CY copieren
        cpl     C               wenn bit 3 = 0 dann dcfsignal = 200 ms = 1
        acall   Rotnti          bits in nti+0 bis nti+5 sammeln
        inc     hsec            Hilfssekunde erhhen
        mov     A,hsec

        cjne    A,#14,dy1       Paritt der secbits 1-10 in secbits 11-14 aufheben
        mov     A,nti+4
        anl     A,#%11111100    secbit 0 und bit 0 ausblenden
        xrl     A,nti+5         secbit 1-6 mit secbit 7-14 in A
        mov     nti+5,A         und nti+5
        anl     nti+5,#$f0      High-Nibble XOR Low-Nibble -> High-Nibble
        swap    A
        anl     A,#$f0
        xrl     nti+5,A
        ajmp    dsx

dy1     cjne    A,#58,dsx       hsec=58?
        mov     A,nti+1         ja, teste Startbit
        jnb     A.1,ds1         S=1?

        mov     A,nti+2         ja, teste ob Parity bis P1 gerade
        anl     A,#%00000011
        xrl     A,nti+1
        xrl     A,nti+0
        add     A,#0            um Parity-Flag auszuwerten
        jb      P,ds1           Parity gerade?

        mov     A,nti+3         ja, bis P2 testen
        rrc     A               P2 in CY
        mov     A,nti+2
        anl     A,#%11111100
        rrc     A               CY in A, P-Flag schon gesetzt
        jb      P,ds1           Parity gerade?

        mov     A,nti+3         ja, bis P3 testen
        anl     A,#%11111110
        xrl     A,nti+4
        xrl     A,nti+5
        add     A,#0            P-Flag
        jb      P,ds1           Parity gerade?

        mov     sec,#58         ja, sec auf 58 setzen
        setb    dcfst.1         Datasync fertig und gltig markieren
dsx     ret                     nein, exit

ds1     mov     dcfst,#0        nein, kompletten sync von vorne
        ret

Rotnti
        push    0
        push    1

        mov     R0,#nti+5       mit nti+5 beginnen
        mov     R1,#6           6 Byte Rotierbreite, bis nti+0

rn1     mov     A,[R0]          Byte holen
        rrc     A               CY von links in nti+x hineinrotieren
        mov     [R0],A          Byte sichern
        dec     R0              nchstes Byte vorbereiten
        djnz    R1,rn1

        pop     1
        pop     0
        ret

Secsync
        jnb     dcfst.2,sy1     wenn bit 2 = 1 UND
        jnb     dcfst.3,sy1     bit 3 = 1
        mov     hsec,#$ff       dann sec=59, hsec=$ff
        setb    dcfst.0         Secsync ausgefhrt
        ret

sy1     inc     hsec            bei falschem Tsync luft
        mov     A,hsec          Secsync max. 60 s
        cjne    A,#60,syx       hsec schon 60 sec? (hsec=0 in SyncClock)
        mov     dcfst,#0        sync von vorne
syx     ret

ResetT0
        clr     TR0             ja, Timer0 stop
        mov     T0ovc,#0        Overflowzhler zurcksetzen
        mov     TL0,#0          Timer0 mit Startwert laden
        mov     TH0,#0
        setb    TR0             Timer0 starten
        ret

*========================================================================

* $08 - $18 for DCF
widco   EQU     $19             width counter
secz    EQU     $1a             second counter for roundcheck
dstat   EQU     $1b             dcfstatus display byte
swmode  EQU     $1c             switch mode for display
swsec   EQU     $1d             switch second counter
delrate EQU     $1e

stack   DATA    $60
SWTIME  EQU     3               switch time in seconds
MAXD1   EQU     36              number of data1
BAREL   EQU     -24             Baudrate reload 2400 BAUD
*                               -48 11,05920 MHz, no predivision
*                               -52 12 MHz, no predivision
DELSTART EQU    -50             delayrate start

C_COMB  EQU     $a5
C_FILLA EQU     $51
C_RCHK  EQU     $52
C_DELAY EQU     $53

main
        mov     IE,#0           alle IR's sperren und lschen
        mov     SP,#(stack-1)   Stack umlegen

        acall   InitDCF
        acall   T1ser           init T1 for seriell
        acall   rchk

        setb    IT0             Flanken-Triggerung ExtIR0 vorbereiten
        clr     PX0             Prioritt ExtIR0
        setb    EX0             Ext0IR enable

        clr     A
        mov     dstat,A         reset status
        mov     swmode,A        reset
        mov     swsec,A         reset
        mov     delrate,#DELSTART

?m0     mov     A,swsec
        jz      ?m5
        acall   switch

?m5     mov     widco,#MAXD1    reset width counter

        mov     A,sec
?m3     cjne    A,sec,?m2
        sjmp    ?m3

?m2     acall   cfilla

        mov     A,swmode
        cjne    A,#0,?msw2
?msw0   acall   timedisp
        sjmp    ?m6
?msw2   cjne    A,#1,?msw3
?msw1   acall   datedisp
        sjmp    ?m6
?msw3   cjne    A,#2,?msw4
        mov     A,secz
        anl     A,#$04
?msw9   jz      ?msw0
        sjmp    ?msw1
?msw4   cjne    A,#3,?msw5
        mov     A,secz
        anl     A,#$08
        sjmp    ?msw9
?msw5

?m6     acall   statdisp
        acall   fillrest

        dec     secz
        mov     A,secz
        jnz     ?m4
        acall   rchk

?m4     sjmp    ?m0

switch
        mov     R5,#0           swbyte start with 0
        mov     R6,#1           copy of swbyte start with 1

?sw0    mov     R7,sec          store sec in R7
?sw2    mov     A,R7            move to A
        cjne        A,sec,?sw1  next second reached?
        mov     A,R6            no
        xrl     A,R5            swbyte in A
        jz      ?sw2            swbyte changed?
        mov     widco,#MAXD1    yes, reset width counter
        acall   cfilla          display swbyte
        mov     A,R5            swbyte
        acall   Aout
        acall   fillrest        fill rest of display
        mov     R6,?R5          copy swbyte
        sjmp    ?sw2            redo above

?sw1    dec     swsec           yes, next second
        mov     A,swsec         redo above if switch is not
        jnz     ?sw0            pressed in SWTIME seconds

        mov     A,R5            SWTIME seconds over
        cjne    A,#4,?sw3       execute choosen command
?sw9    mov     A,delrate
        ajmp    cdelay
?sw3    cjne    A,#5,?sw4
        mov     A,#0
        ajmp    cdelay
?sw4    cjne    A,#6,?sw5
        dec     delrate
        sjmp    ?sw9
?sw5    cjne    A,#7,?sw6
        inc     delrate
        sjmp    ?sw9
?sw6
        anl     ?R5,#$03
        mov     swmode,R5       in cases 0-3
        ret

cfilla
        mov     A,#C_COMB       send fillall command
        acall   wrchr
        mov     A,#C_FILLA
        ajmp    wrchr

fillrest
        mov     A,#$ff          send empty bytes till
?fr1    acall   wrsgb           display is full
        jc      ?fr1
        ret

datedisp
        mov     A,day
        anl     A,#$1f
        acall   Aout
        mov     A,#$0b
        acall   chrout

        mov     A,month
        acall   Aout
        mov     A,#$0b
        acall   chrout

        mov     A,year
        sjmp    Aout

timedisp
        mov     A,hou
        acall   Aout
        mov     A,#$0a
        acall   chrout

        mov     A,min
        acall   Aout
        mov     A,#$0a
        acall   chrout

        mov     A,sec
        sjmp    Aout

statdisp
        clr     A               reset A
        mov     B,A             collector reset
        jnb     dcfst.6,?sp1    tsync?
        setb    B.0             yes, collect
?sp1    jnb     dcfst.0,?sp2    secsync?
        setb    B.1             yes, collect
?sp2    jnb     dcfst.7,?sp7    sync?
        setb    B.2             yes, collect
        mov     A,nti           reserve-antenna-bit?
        jnb     A.4,?sp3
        setb    B.3             yes, collect
?sp3    mov     A,dstat         fetch old status
        jnz     ?sp4            w/s-bits = 0?
        mov     dstat,#$80      yes, reinit them
?sp4    mov     A,nti           w/s-bit set?
        jnb     A.6,?sp5
        mov     A,dstat         yes, summer
        rr      A               rotate down
        cjne    A,#$08,?sp7     overflow?
        mov     A,#$80          yes, reinit
        sjmp    ?sp7            display
?sp5    mov     A,dstat         winter
        clr     CY              clear carry
        rlc     A               rotate up
        jnc     ?sp7            overflow?
        mov     A,#$10          yes, reinit

?sp7    mov     dstat,A         save w/s-bits
        orl     A,B             w/s-bits OR collector
        xrl     A,#$ff          invert it
        sjmp    wrsgb           display it

cdelay
        push    A
        mov     A,#C_COMB       send roundcheck-command
        acall   wrchr
        mov     A,#C_DELAY
        acall   wrchr
        pop     A
        sjmp    wrchr

Aout
        acall   bin2bcd
        sjmp    twoout

rchk
        mov     A,#C_COMB       send roundcheck-command
        acall   wrchr
        mov     A,#C_RCHK
        sjmp    wrchr

bin2bcd
        mov     B,#10
        div     AB
        rl      A
        rl      A
        rl      A
        rl      A
        orl     A,B
        ret

twoout
        push    A               send the 2 bcd-digits in A
        swap    A
        acall   chrout
        pop     A
        acall   chrout
        ret

T1ser
        clr     TR1             stop T1
        clr     ES              disable seriel-IR
        clr     ET1             disable T1-IR
        setb    TI              write buffer is empty
        anl     TMOD,#$0f       T1 vorbereiten ohne T0 zu verndern
        orl     TMOD,#$20       Gate1=0, c/t1=0, Mode1=02 8-bit autoreload
        mov     TH1,#BAREL      baudrate relaod
        mov     TL1,TH1         startvalue
        setb    TR1             start Timer1
        orl     PCON,#$80       SMOD=1, no predivision
        mov     SCON,#$52       mode 1, async. 8 bit, sm2=0 no stopbit
*                               TB8=0, RB8=0, TI=1, REN=1, RI=1
        ret

wrsgb
        mov     B,A             save A
        dec     widco
        mov     A,widco
        clr     CY              writing failed
        jb      A.7,?wr1        if widco is negative
        mov     A,B             restore A

wrchr
        jnb     TI,*            wait for SBUF empty
        mov     SBUF,A          start transmission
        clr     TI              mark start
        setb    CY              writing ok
?wr1    ret

Ext0Int
        inc     R5
        mov     swsec,#SWTIME
        reti

chrout
        anl     A,#$0f          send lower bcd-digit in A ROM-VERSION
        mov     B,#TABWIDTH     * tablewidth
        mul     AB
        add     A,#chrmat       + tablestart
        mov     DPL,A
        mov     A,#=chrmat
        addc    A,#0
        mov     DPH,A

        clr     A
        movc    A,@A+DPTR       fetch signwidth
        mov     R0,A            store in R0
        inc     DPTR            next byte in table is signdata

?choF   clr     A
        movc    A,@A+DPTR       fetch signdata
        acall   wrsgb           send it
        inc     DPTR            next signdata
        djnz    R0,?choF        signwith reached?

        mov     A,#$ff          gap between signs
        sjmp    wrsgb

*chroutR
*       anl     A,#$0f          send lower bcd-digit in A RAM-VERSION
*       mov     B,#TABWIDTH     * tablewidth
*       mul     AB
*       add     A,#chrmat       + tablestart
*       mov     DPL,A
*       mov     A,#=chrmat
*       addc    A,#0
*       mov     DPH,A
*
*       movx    A,[DPTR]        fetch signwidth
*       mov     R0,A            store in R0
*       inc     DPTR            next byte in table is signdata
*
*?choR  movx    A,[DPTR]        fetch signdata
*       acall   wrsgb           send it
*       inc     DPTR            next signdata
*       djnz    R0,?choR        signwith reached?
*
*       mov     A,#$ff          gap between signs
*       sjmp    wrsgb


TABWIDTH    EQU 5

chrmat
    * '0'
    DB $04,$00,$7E,$7E,$00
    * '1'
    DB $04,$7E,$00,$FE,$F8
    * '2'
    DB $04,$60,$6E,$6E,$0E
    * '3'
    DB $04,$7E,$6E,$6E,$10
    * '4'
    DB $04,$07,$F7,$F7,$80
    * '5'
    DB $04,$FE,$0E,$6E,$60
    * '6'
    DB $04,$00,$EE,$EE,$E0
    * '7'
    DB $04,$7F,$70,$6F,$1F
    * '8'
    DB $04,$E0,$0E,$6E,$00
    * '9'
    DB $04,$0F,$6F,$6F,$00
    * ':'
    DB $01,$DB,$FF,$FF,$FF
    * '.'
    DB $01,$FE
